var formats = {
    "+247": {
        country: "AC"
    },
    "+376": {
        country: "AD",
        format: "+... ... ..."
    },
    "+971": {
        country: "AE",
        format: "+... .. ... ...."
    },
    "+93": {
        country: "AF",
        format: "+.. .. ... ...."
    },
    "+1268": {
        country: "AG"
    },
    "+1264": {
        country: "AI"
    },
    "+355": {
        country: "AL",
        format: "+... .. ... ...."
    },
    "+374": {
        country: "AM",
        format: "+... .. ......"
    },
    "+244": {
        country: "AO",
        format: "+... ... ... ..."
    },
    "+54": {
        country: "AR",
        format: "+.. .. ..-....-...."
    },
    "+1684": {
        country: "AS"
    },
    "+43": {
        country: "AT",
        format: "+.. ... ......"
    },
    "+61": {
        country: "AU",
        format: "+.. ... ... ..."
    },
    "+297": {
        country: "AW",
        format: "+... ... ...."
    },
    "+994": {
        country: "AZ",
        format: "+... .. ... .. .."
    },
    "+387": {
        country: "BA",
        format: "+... .. ...-..."
    },
    "+1246": {
        country: "BB"
    },
    "+880": {
        country: "BD",
        format: "+... ....-......"
    },
    "+32": {
        country: "BE",
        format: "+.. ... .. .. .."
    },
    "+226": {
        country: "BF",
        format: "+... .. .. .. .."
    },
    "+359": {
        country: "BG",
        format: "+... ... ... .."
    },
    "+973": {
        country: "BH",
        format: "+... .... ...."
    },
    "+257": {
        country: "BI",
        format: "+... .. .. .. .."
    },
    "+229": {
        country: "BJ",
        format: "+... .. .. .. .."
    },
    "+1441": {
        country: "BM"
    },
    "+673": {
        country: "BN",
        format: "+... ... ...."
    },
    "+591": {
        country: "BO",
        format: "+... ........"
    },
    "+55": {
        country: "BR",
        format: "+.. .. .....-...."
    },
    "+1242": {
        country: "BS"
    },
    "+975": {
        country: "BT",
        format: "+... .. .. .. .."
    },
    "+267": {
        country: "BW",
        format: "+... .. ... ..."
    },
    "+375": {
        country: "BY",
        format: "+... .. ...-..-.."
    },
    "+501": {
        country: "BZ",
        format: "+... ...-...."
    },
    "+243": {
        country: "CD",
        format: "+... ... ... ..."
    },
    "+236": {
        country: "CF",
        format: "+... .. .. .. .."
    },
    "+242": {
        country: "CG",
        format: "+... .. ... ...."
    },
    "+41": {
        country: "CH",
        format: "+.. .. ... .. .."
    },
    "+225": {
        country: "CI",
        format: "+... .. .. .. .."
    },
    "+682": {
        country: "CK",
        format: "+... .. ..."
    },
    "+56": {
        country: "CL",
        format: "+.. . .... ...."
    },
    "+237": {
        country: "CM",
        format: "+... .. .. .. .."
    },
    "+86": {
        country: "CN",
        format: "+.. ... .... ...."
    },
    "+57": {
        country: "CO",
        format: "+.. ... ......."
    },
    "+506": {
        country: "CR",
        format: "+... .... ...."
    },
    "+53": {
        country: "CU",
        format: "+.. . ......."
    },
    "+238": {
        country: "CV",
        format: "+... ... .. .."
    },
    "+599": {
        country: "CW",
        format: "+... . ... ...."
    },
    "+537": {
        country: "CY"
    },
    "+357": {
        country: "CY",
        format: "+... .. ......"
    },
    "+420": {
        country: "CZ",
        format: "+... ... ... ..."
    },
    "+49": {
        country: "DE",
        format: "+.. .... ......."
    },
    "+253": {
        country: "DJ",
        format: "+... .. .. .. .."
    },
    "+45": {
        country: "DK",
        format: "+.. .. .. .. .."
    },
    "+1767": {
        country: "DM"
    },
    "+1849": {
        country: "DO"
    },
    "+213": {
        country: "DZ",
        format: "+... ... .. .. .."
    },
    "+593": {
        country: "EC",
        format: "+... .. ... ...."
    },
    "+372": {
        country: "EE",
        format: "+... .... ...."
    },
    "+20": {
        country: "EG",
        format: "+.. ... ... ...."
    },
    "+291": {
        country: "ER",
        format: "+... . ... ..."
    },
    "+34": {
        country: "ES",
        format: "+.. ... .. .. .."
    },
    "+251": {
        country: "ET",
        format: "+... .. ... ...."
    },
    "+358": {
        country: "FI",
        format: "+... .. ... .. .."
    },
    "+679": {
        country: "FJ",
        format: "+... ... ...."
    },
    "+500": {
        country: "FK"
    },
    "+691": {
        country: "FM",
        format: "+... ... ...."
    },
    "+298": {
        country: "FO",
        format: "+... ......"
    },
    "+33": {
        country: "FR",
        format: "+.. . .. .. .. .."
    },
    "+241": {
        country: "GA",
        format: "+... .. .. .. .."
    },
    "+44": {
        country: "GB",
        format: "+.. .... ......"
    },
    "+1473": {
        country: "GD"
    },
    "+995": {
        country: "GE",
        format: "+... ... .. .. .."
    },
    "+594": {
        country: "GF",
        format: "+... ... .. .. .."
    },
    "+233": {
        country: "GH",
        format: "+... .. ... ...."
    },
    "+350": {
        country: "GI",
        format: "+... ... ....."
    },
    "+299": {
        country: "GL",
        format: "+... .. .. .."
    },
    "+220": {
        country: "GM",
        format: "+... ... ...."
    },
    "+224": {
        country: "GN",
        format: "+... ... .. .. .."
    },
    "+240": {
        country: "GQ",
        format: "+... ... ... ..."
    },
    "+30": {
        country: "GR",
        format: "+.. ... ... ...."
    },
    "+502": {
        country: "GT",
        format: "+... .... ...."
    },
    "+1671": {
        country: "GU"
    },
    "+245": {
        country: "GW",
        format: "+... ... ...."
    },
    "+592": {
        country: "GY",
        format: "+... ... ...."
    },
    "+852": {
        country: "HK",
        format: "+... .... ...."
    },
    "+504": {
        country: "HN",
        format: "+... ....-...."
    },
    "+385": {
        country: "HR",
        format: "+... .. ... ...."
    },
    "+509": {
        country: "HT",
        format: "+... .. .. ...."
    },
    "+36": {
        country: "HU",
        format: "+.. .. ... ...."
    },
    "+62": {
        country: "ID",
        format: "+.. ...-...-..."
    },
    "+353": {
        country: "IE",
        format: "+... .. ... ...."
    },
    "+972": {
        country: "IL",
        format: "+... ..-...-...."
    },
    "+91": {
        country: "IN",
        format: "+.. .. .. ......"
    },
    "+246": {
        country: "IO",
        format: "+... ... ...."
    },
    "+964": {
        country: "IQ",
        format: "+... ... ... ...."
    },
    "+98": {
        country: "IR",
        format: "+.. ... ... ...."
    },
    "+354": {
        country: "IS",
        format: "+... ... ...."
    },
    "+39": {
        country: "IT",
        format: "+.. .. .... ...."
    },
    "+1876": {
        country: "JM"
    },
    "+962": {
        country: "JO",
        format: "+... . .... ...."
    },
    "+81": {
        country: "JP",
        format: "+.. ..-....-....",
        nationalPrefix: "0"
    },
    "+254": {
        country: "KE",
        format: "+... .. ......."
    },
    "+996": {
        country: "KG",
        format: "+... ... ... ..."
    },
    "+855": {
        country: "KH",
        format: "+... .. ... ..."
    },
    "+686": {
        country: "KI"
    },
    "+269": {
        country: "KM",
        format: "+... ... .. .."
    },
    "+1869": {
        country: "KN"
    },
    "+850": {
        country: "KP",
        format: "+... ... ... ...."
    },
    "+82": {
        country: "KR",
        format: "+.. ..-....-...."
    },
    "+965": {
        country: "KW",
        format: "+... ... ....."
    },
    "+345": {
        country: "KY"
    },
    "+77": {
        country: "KZ"
    },
    "+856": {
        country: "LA",
        format: "+... .. .. ... ..."
    },
    "+961": {
        country: "LB",
        format: "+... .. ... ..."
    },
    "+1758": {
        country: "LC"
    },
    "+423": {
        country: "LI",
        format: "+... ... ... ..."
    },
    "+94": {
        country: "LK",
        format: "+.. .. . ......"
    },
    "+231": {
        country: "LR",
        format: "+... ... ... ..."
    },
    "+266": {
        country: "LS",
        format: "+... .... ...."
    },
    "+370": {
        country: "LT",
        format: "+... ... ....."
    },
    "+352": {
        country: "LU",
        format: "+... .. .. .. ..."
    },
    "+371": {
        country: "LV",
        format: "+... .. ... ..."
    },
    "+218": {
        country: "LY",
        format: "+... ..-......."
    },
    "+212": {
        country: "MA",
        format: "+... ...-......"
    },
    "+377": {
        country: "MC",
        format: "+... . .. .. .. .."
    },
    "+373": {
        country: "MD",
        format: "+... ... .. ..."
    },
    "+382": {
        country: "ME",
        format: "+... .. ... ..."
    },
    "+590": {
        country: "MF"
    },
    "+261": {
        country: "MG",
        format: "+... .. .. ... .."
    },
    "+692": {
        country: "MH",
        format: "+... ...-...."
    },
    "+389": {
        country: "MK",
        format: "+... .. ... ..."
    },
    "+223": {
        country: "ML",
        format: "+... .. .. .. .."
    },
    "+95": {
        country: "MM",
        format: "+.. . ... ...."
    },
    "+976": {
        country: "MN",
        format: "+... .... ...."
    },
    "+853": {
        country: "MO",
        format: "+... .... ...."
    },
    "+1670": {
        country: "MP"
    },
    "+596": {
        country: "MQ",
        format: "+... ... .. .. .."
    },
    "+222": {
        country: "MR",
        format: "+... .. .. .. .."
    },
    "+1664": {
        country: "MS"
    },
    "+356": {
        country: "MT",
        format: "+... .... ...."
    },
    "+230": {
        country: "MU",
        format: "+... .... ...."
    },
    "+960": {
        country: "MV",
        format: "+... ...-...."
    },
    "+265": {
        country: "MW",
        format: "+... ... .. .. .."
    },
    "+52": {
        country: "MX",
        format: "+.. ... ... ... ...."
    },
    "+60": {
        country: "MY",
        format: "+.. ..-... ...."
    },
    "+258": {
        country: "MZ",
        format: "+... .. ... ...."
    },
    "+264": {
        country: "NA",
        format: "+... .. ... ...."
    },
    "+687": {
        country: "NC",
        format: "+... ........"
    },
    "+227": {
        country: "NE",
        format: "+... .. .. .. .."
    },
    "+672": {
        country: "NF",
        format: "+... .. ...."
    },
    "+234": {
        country: "NG",
        format: "+... ... ... ...."
    },
    "+505": {
        country: "NI",
        format: "+... .... ...."
    },
    "+31": {
        country: "NL",
        format: "+.. . ........"
    },
    "+47": {
        country: "NO",
        format: "+.. ... .. ..."
    },
    "+977": {
        country: "NP",
        format: "+... ...-......."
    },
    "+674": {
        country: "NR",
        format: "+... ... ...."
    },
    "+683": {
        country: "NU"
    },
    "+64": {
        country: "NZ",
        format: "+.. .. ... ...."
    },
    "+968": {
        country: "OM",
        format: "+... .... ...."
    },
    "+507": {
        country: "PA",
        format: "+... ....-...."
    },
    "+51": {
        country: "PE",
        format: "+.. ... ... ..."
    },
    "+689": {
        country: "PF",
        format: "+... .. .. .."
    },
    "+675": {
        country: "PG",
        format: "+... ... ...."
    },
    "+63": {
        country: "PH",
        format: "+.. .... ......"
    },
    "+92": {
        country: "PK",
        format: "+.. ... ......."
    },
    "+48": {
        country: "PL",
        format: "+.. .. ... .. .."
    },
    "+508": {
        country: "PM",
        format: "+... .. .. .."
    },
    "+872": {
        country: "PN"
    },
    "+1939": {
        country: "PR"
    },
    "+970": {
        country: "PS",
        format: "+... ... ... ..."
    },
    "+351": {
        country: "PT",
        format: "+... ... ... ..."
    },
    "+680": {
        country: "PW",
        format: "+... ... ...."
    },
    "+595": {
        country: "PY",
        format: "+... .. ......."
    },
    "+974": {
        country: "QA",
        format: "+... .... ...."
    },
    "+262": {
        country: "RE"
    },
    "+40": {
        country: "RO",
        format: "+.. .. ... ...."
    },
    "+381": {
        country: "RS",
        format: "+... .. ......."
    },
    "+7": {
        country: "RU",
        format: "+. ... ...-..-.."
    },
    "+250": {
        country: "RW",
        format: "+... ... ... ..."
    },
    "+966": {
        country: "SA",
        format: "+... .. ... ...."
    },
    "+677": {
        country: "SB",
        format: "+... ... ...."
    },
    "+248": {
        country: "SC",
        format: "+... . ... ..."
    },
    "+249": {
        country: "SD",
        format: "+... .. ... ...."
    },
    "+46": {
        country: "SE",
        format: "+.. ..-... .. .."
    },
    "+65": {
        country: "SG",
        format: "+.. .... ...."
    },
    "+290": {
        country: "SH"
    },
    "+386": {
        country: "SI",
        format: "+... .. ... ..."
    },
    "+421": {
        country: "SK",
        format: "+... ... ... ..."
    },
    "+232": {
        country: "SL",
        format: "+... .. ......"
    },
    "+378": {
        country: "SM",
        format: "+... .. .. .. .."
    },
    "+221": {
        country: "SN",
        format: "+... .. ... .. .."
    },
    "+252": {
        country: "SO",
        format: "+... .. ......."
    },
    "+597": {
        country: "SR",
        format: "+... ...-...."
    },
    "+211": {
        country: "SS",
        format: "+... ... ... ..."
    },
    "+239": {
        country: "ST",
        format: "+... ... ...."
    },
    "+503": {
        country: "SV",
        format: "+... .... ...."
    },
    "+963": {
        country: "SY",
        format: "+... ... ... ..."
    },
    "+268": {
        country: "SZ",
        format: "+... .... ...."
    },
    "+1649": {
        country: "TC"
    },
    "+235": {
        country: "TD",
        format: "+... .. .. .. .."
    },
    "+228": {
        country: "TG",
        format: "+... .. .. .. .."
    },
    "+66": {
        country: "TH",
        format: "+.. .. ... ...."
    },
    "+992": {
        country: "TJ",
        format: "+... ... .. ...."
    },
    "+690": {
        country: "TK"
    },
    "+670": {
        country: "TL",
        format: "+... .... ...."
    },
    "+993": {
        country: "TM",
        format: "+... .. ..-..-.."
    },
    "+216": {
        country: "TN",
        format: "+... .. ... ..."
    },
    "+676": {
        country: "TO",
        format: "+... ... ...."
    },
    "+90": {
        country: "TR",
        format: "+.. ... ... ...."
    },
    "+1868": {
        country: "TT"
    },
    "+688": {
        country: "TV"
    },
    "+886": {
        country: "TW",
        format: "+... ... ... ..."
    },
    "+255": {
        country: "TZ",
        format: "+... ... ... ..."
    },
    "+380": {
        country: "UA",
        format: "+... .. ... ...."
    },
    "+256": {
        country: "UG",
        format: "+... ... ......"
    },
    "+1": {
        country: "US",
        format: "+. (...) ...-..."
    },
    "+598": {
        country: "UY",
        format: "+... .... ...."
    },
    "+998": {
        country: "UZ",
        format: "+... .. ... .. .."
    },
    "+379": {
        country: "VA"
    },
    "+1784": {
        country: "VC"
    },
    "+58": {
        country: "VE",
        format: "+.. ...-......."
    },
    "+1284": {
        country: "VG"
    },
    "+1340": {
        country: "VI"
    },
    "+84": {
        country: "VN",
        format: "+.. .. ... .. .."
    },
    "+678": {
        country: "VU",
        format: "+... ... ...."
    },
    "+681": {
        country: "WF",
        format: "+... .. .. .."
    },
    "+685": {
        country: "WS"
    },
    "+967": {
        country: "YE",
        format: "+... ... ... ..."
    },
    "+27": {
        country: "ZA",
        format: "+.. .. ... ...."
    },
    "+260": {
        country: "ZM",
        format: "+... .. ......."
    },
    "+263": {
        country: "ZW",
        format: "+... .. ... ...."
    }
};
var specials = ['-', ' ', '+', '(', ')'];
var defaultFormat = {
    format: "+.........",
    country: ''
};
var phoneBuller = null;
var currentCountryPhone = null;


function insert(text, index, char) {
   return text.substring(0, index) + char + text.substring(index);
};

function remove(text, index) {
   return text.substring(0, index-1) + text.substring(index);
}

function find(el, arr) {

  for (var i = 0; i < arr.length; ++i) {
    if(el == arr[i]) return true
  }

  return false
}

function getFormatModel(text) {

  text = '+' + text.replace(/[^0-9]/g, '');

  for (field in formats) {
    var initText = text.substring(0, field.length);
    if( field == initText ) return formats[field]
  }

  return defaultFormat

}

function format(text, cursorPos, type, formatModel) {

  if(formatModel == undefined) formatModel = defaultFormat.format;

  text = text.replace(/[^0-9]/g, '');

  var newText = '';
  var i = 0;
  var j = 0;

  while (i < formatModel.length && j < text.length) {
    
    if (formatModel[i] != '.') {
      newText += formatModel[i];
    } else {
      if (find( text[j], specials )) {
        j++
      }
      if(text[j]) {
        newText += text[j];
      }
      j++
    }
    i++
  }

  if (j < text.length) {
    newText += text.substring(j).replace(/[^0-9]/g, '');
  }

  if (find(newText[newText.length - 1], specials)) {
    newText = newText.substring(0, newText.length-1);
  }

  return newText
}

function PhoneNumber (el) {
  function setup () {
    el.addEventListener('keydown', function (e) {

      var keyCode = e.keyCode
      var text = el.value
      var currentPosition = text.slice(0, el.selectionStart).length
      

      if( !(keyCode == '39' || keyCode == '37') ) {

        e.preventDefault()

        if (keyCode == '8') { // is delete
          
          if (find(text[currentPosition-1], specials)) {

            el.setSelectionRange(currentPosition-1, currentPosition-1);
            // el.moveStart("character", currentPosition-1);

          } else {

            var virtualText = remove(text, currentPosition);
            var formatObj = getFormatModel(virtualText);
            var newText = format(virtualText, currentPosition, 'delete', formatObj.format);

            el.value = newText;

            var c = newText[currentPosition];

            el.setSelectionRange(currentPosition - 1, currentPosition - 1);

          }

        } else { // is number
          
          var number = String.fromCharCode(e.which)

          var isNumber = /[\d\s]/.test(number)
          console.log('isNumber: ', isNumber)

          if( isNumber ) {
            
            var virtualText = insert(text, currentPosition, number)

            var formatObj = getFormatModel(virtualText)
            console.log('formatObj: ', formatObj)

            var newText = format(virtualText, currentPosition, 'insert', formatObj.format)

            el.value = newText

            var c = newText[currentPosition]
            var c1 = newText[currentPosition + 1]
            console.log('c: ', c)

            if (find(c, specials)) {
                console.log('special')
                if (find(c1, specials)) {
                    el.setSelectionRange(currentPosition + 3, currentPosition + 3);
                } else {
                    el.setSelectionRange(currentPosition + 2, currentPosition + 2);
                }
            } else {
                console.log('number')
                el.setSelectionRange(currentPosition + 1, currentPosition + 1)
            }
          }
        }
      }
    })
  }

  setup();
}


module.export = {
  autoFormatPhone: PhoneNumber
};